//
// This project was used for testing the TagInsight Technology
//   non-visual component, this the reason why the component is
//   not dropped on the TForm
//
//
// @@signature: $EOF_PASCAL
//
unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, SyntaxEd, SynParse, ComCtrls, StdCtrls, dxTagInsightCmp,
  dxEdComponent, Buttons, ShellAPI;

type
  TForm1 = class(TForm)
    pnlTop: TPanel;
    Bevel1: TBevel;
    btnAbout: TButton;
    pnlStatus: TPanel;
    btnAttribute: TButton;
    pnlVersion: TPanel;
    staMain: TStatusBar;
    Panel3: TPanel;
    FEditor: TSyntaxMemo;
    synParseHTML: TSyntaxMemoParser;
    FTimer: TTimer;
    Panel5: TPanel;
    tbnEditor_TagInsight: TSpeedButton;
    tbnEditor_TagCompletion: TSpeedButton;
    tbnEditor_Gutter: TSpeedButton;
    tbnEditor_LineNums: TSpeedButton;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FEditorDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FEditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tbnEditor_TagInsightClick(Sender: TObject);
    procedure tbnEditor_TagCompletionClick(Sender: TObject);
    procedure tbnEditor_GutterClick(Sender: TObject);
    procedure tbnEditor_LineNumsClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure FTimerTimer(Sender: TObject);
    procedure btnAttributeClick(Sender: TObject);
  private
    { Private declarations }
    FTagInsight : TdxTagInsightCmp;
    Procedure Executed ( Sender : TObject );

    procedure CustomDraw ( Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UnitAbout;

{$R *.DFM}

procedure TForm1.FormDestroy(Sender: TObject);
begin
 FTagInsight.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 //
 // Creating an instance of TdxTagInsightCmp-class
 //
 //
 FTagInsight := TdxTagInsightCmp.Create ( FEditor );
 FTagInsight.Editor     := FEditor;
 FTagInsight.TagDefinitionsFile := 'TagInsight.xml';
 FTagInsight.OnExecute  := Executed;
 FTagInsight.Active     := True;

 FTagInsight.Options    := [ tioTagInsight, tioTagHint ];
 FTagInsight.CustomDraw := True;
 FTagInsight.OnDrawItem := CustomDraw;
 pnlVersion.Caption := 'TagInsight Technology Version ' +  FTagInsight.Version + ' for HTML';
 ( FTagInsight.Editor as TSyntaxMemo ).Options := ( FTagInsight.Editor as TSyntaxMemo ).Options -  [smoShowGutter] ;
 ( FTagInsight.Editor as TSyntaxMemo ).Parser1 := synParseHTML;

 tbnEditor_LineNums.Down   := ( smoLineNumbers in FEditor.Options ) = True;
 tbnEditor_Gutter.Down     := ( smoShowGutter in FEditor.Options ) = True;
end;

procedure TForm1.Executed(Sender: TObject);
begin
 ShowMessage ( 'Executed' );
end;

procedure TForm1.FEditorDblClick(Sender: TObject);
begin
 FTagInsight.Execute;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 ( FTagInsight.Editor as TSyntaxMemo ).Options := ( FTagInsight.Editor as TSyntaxMemo ).Options -  [smoShowGutter] ;
 FTagInsight.Editor.ModifyProperties;
end;

procedure TForm1.FEditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

 If tioTagInsight in FTagInsight.Options then
    staMAin.Panels[0].Text := 'TagInsight=on'
 else
    staMAin.Panels[0].Text := 'TagInsight=off';

end;

procedure TForm1.CustomDraw(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
 //
end;

procedure TForm1.tbnEditor_TagInsightClick(Sender: TObject);
begin
 If ( tbnEditor_TagInsight.Down = True ) then
    FTagInsight.Options  := FTagInsight.Options + [ tioTagInsight ]
 else
    FTagInsight.Options  := FTagInsight.Options - [ tioTagInsight ];
end;

procedure TForm1.tbnEditor_TagCompletionClick(Sender: TObject);
begin
 If tbnEditor_TagCompletion.Down then
  FTagInsight.Options := FTagInsight.Options + [ tioTagCompletion ]
 else
  FTagInsight.Options := FTagInsight.Options - [ tioTagCompletion ];
end;

procedure TForm1.tbnEditor_GutterClick(Sender: TObject);
begin
 If tbnEditor_Gutter.Down then
  FEditor.Options := FEditor.Options + [ smoShowGutter ]
 else
  FEditor.Options := FEditor.Options - [ smoShowGutter ];
end;

procedure TForm1.tbnEditor_LineNumsClick(Sender: TObject);
begin
 If tbnEditor_LineNums.Down then
  FEditor.Options := FEditor.Options + [ smoLineNumbers ]
 else
  FEditor.Options := FEditor.Options - [ smoLineNumbers ];
end;

procedure TForm1.btnAboutClick(Sender: TObject);
begin
 //
 // @@orginal name: btnTag
 // @@orginal purpose: Checking if the TagName is correctly
 //                    detected.
 //
 // Not used in published in demo version,
 // only in developer version of this testing project!
 //
 //
 fAbout.ShowModal
end;

procedure TForm1.FTimerTimer(Sender: TObject);
begin
 //
end;

procedure TForm1.btnAttributeClick(Sender: TObject);
Var
   MsgRes : Integer;
Const
   EmailAddress = 'weyert@xs4all.nl';
   WebSite      = 'http://www.xs4all.nl/~dbcons/dbsoftware/index.html';
   Text         = 'Do also you want to connect to ours company web-site?';
begin
 //
 // Start up the internet browser, and the
 //   mail client of the user!
 // Orginal code:
 //
 //         SQ    := TStringResourceStream.Create --> Requires company add ons
 //         MessageBox ( Handle, Nil , PChar(SQ.LoadStr(Internet)), x);
 MsgRes   := MessageBox ( Handle, PChar(Text), Nil, ( MB_APPLMODAL or  MB_YESNO or MB_ICONQUESTION and MB_DEFBUTTON1 ) );
 If MsgRes = IDYES
    then begin
      // Okay we may load the internet browser!
      //
      ShellExecute ( Handle, Nil, PChar(WebSite), nil, nil, SW_SHOWDEFAULT );
    end;
    ShellExecute ( Handle, Nil, PChar('mailto:' + EmailAddress), nil, nil, SW_SHOWDEFAULT );
end;

end.

//:: @@Project: TagInsight Technology Demo
//:: (c) 1999 Weyert R. de Boer - Weyert@xs4all.nl
//:: Generated on 19/10/99 at 08:21:21
//:: ${FILE_KEY}

